﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr231_1
{
    // Класс исключения: 
    class MyException: Exception {
        // Закрытые текстовые поля:
        private string time; 
        private string source;
        // Конструктор создания объекта исключения:
        public MyException(Exception obj): 
            base("Ошибка класса MyException") { 
            // Класс исходной ошибки: 
            source = obj.GetType().Name;
            // Дата и время генерирования ошибки:
            time = DateTime.Now.ToString();
        }
        // Переопределение метода ToString(): 
        public override string ToString() { 
            string txt = Message + "\n"; 
            txt += "Исходный класс ошибки: " + source + "\n"; 
            txt += "Дата и время генерирования: " + time; 
            return txt;
        }
    }
    
    // Главный класс:
    class Program
    {
        // Главный метод:
        static void Main()
        {
            // Внешний try-блок: 
            try {
                // Внутренний try-блок: 
                try {
                    // Массив из одного элемента: 
                    int[] a = {1};
                    // Обращение к несуществующему элементу 
                    // массива (генерирование ошибки): 
                    a[1] = 2;
                }
                // Внутренний catch-блок: 
                catch(Exception e) {
                    // Создание объекта исключения: 
                    MyException me = new MyException(e);
                    // Генерирование исключения: 
                    throw me;
                }
            }
            // Внешний catch-блок: 
            catch(Exception e) {
                Console.WriteLine(e);
            }
            // Задержка:
            Console.ReadLine();
        }
    }
}
